// openhomm - open source clone of Heroes of Might and Magic III
// Copyright (C) 2009-2010 openhomm developers team (see AUTHORS)
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
#pragma once

#include "hrWidget.hpp"

class hrBorder : public hrWidget
{
    Q_OBJECT
public:
    hrBorder(QObject * parent = 0) : hrWidget(parent) { }

    Q_PROPERTY(QString name READ getName WRITE setName)
    QString getName() const;
    void setName(QString name);

    Q_PROPERTY(int width READ getWidth WRITE setWidth)
    int getWidth() const;
    void setWidth(int w);

    Q_PROPERTY(int height READ getHeight WRITE setHeight)
    int getHeight() const;
    void setHeight(int h);

    void resizeBorder(int w, int h);

private:
    QString name;

    hrGraphicsItem topLeft;
    hrGraphicsItem left;
    hrGraphicsItem top;
    hrGraphicsItem bottomLeft;
    hrGraphicsItem bottom;
    hrGraphicsItem topRight;
    hrGraphicsItem right;
    hrGraphicsItem bottomRight;

    void addItem(hrGraphicsItem item, int x, int y);
};
