// openhomm - open source clone of Heroes of Might and Magic III
// Copyright (C) 2009-2010 openhomm developers team (see AUTHORS)
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
#include "precompiled.hpp"
#include "hrPushButton.hpp"
#include "hrCache.hpp"

void hrPushButton::onMousePress()
{
    items[0].setCurFrame(1);
}

void hrPushButton::onMouseRelease()
{
    items[0].setCurFrame(0);
    emit clicked();
}

void hrPushButton::setX(int x)
{
    rect.setRect(x,  rect.y(), rect.width(), rect.height());
    if (!items.isEmpty())
        items[0].setPoint(rect.topLeft());
 }

int hrPushButton::getX() const
{
    return rect.x();
}

void hrPushButton::setY(int y)
{
    rect.setRect(rect.x(),  y, rect.width(), rect.height());
    if (!items.isEmpty())
        items[0].setPoint(rect.topLeft());
}

int hrPushButton::getY() const
{
    return rect.y();
}

QString hrPushButton::getName() const
{
    return name;
}

void hrPushButton::setName(QString name)
{
    this->name = name;
    items.clear();
    hrGraphicsItem item = hrCache::Get().loadItem(name);
    rect.setSize(item.getSize());
    item.setPoint(rect.topLeft());
    items.append(item);
}
