// openhomm - open source clone of Heroes of Might and Magic III
// Copyright (C) 2009-2010 openhomm developers team (see AUTHORS)
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
#pragma once

#include "hrWidget.hpp"
#include "hrGraphicsItem.hpp"

class hrPushButton : public hrWidget
{
    Q_OBJECT
public:
    hrPushButton(QObject * parent = 0) : hrWidget(parent) { }

    Q_PROPERTY(QString name READ getName WRITE setName)
    QString getName() const;
    void setName(QString name);

    Q_PROPERTY(int x READ getX WRITE setX)
    void setX(int x);
    int getX() const;

    Q_PROPERTY(int y READ getY WRITE setY)
    void setY(int y);
    int getY() const;

    void onMousePress();
    void onMouseRelease();

signals:
    void clicked();

private:
    QString name;
};

