// openhomm - open source clone of Heroes of Might and Magic III
// Copyright (C) 2009-2010 openhomm developers team (see AUTHORS)
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
#pragma once

#include <QScriptEngine>
#include <QScriptValue>
#include <QScriptValueIterator>

#include "hrWidget.hpp"

class hrUI : public QObject
{
    Q_OBJECT
public:
    static hrUI & Get()
    {
        static hrUI ui;
        return ui;
    }

    void script(QString path);
    void addGlobalObject(QObject *obj, QString name);

    QListIterator<hrGraphicsItem> getItems();

    void onMousePress(const QPoint &p);
    void onMouseRelease(const QPoint &p);

public slots:
    void addWidget(hrWidget *item);
    void resize(int w, int h);

private:
    hrUI(QObject * parent = 0);

    void collect();

    QVector<hrWidget*> widgets;
    QList<hrGraphicsItem> items;

    QScriptEngine engine;
};
