// openhomm - open source clone of Heroes of Might and Magic III
// Copyright (C) 2009-2010 openhomm developers team (see AUTHORS)
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
#include "precompiled.hpp"
#include "hrWidget.hpp"

hrWidget::hrWidget(QObject *parent) : QObject(parent)
        , corner(0)
{
    corner |= topLeft;
}

QRect hrWidget::getRect() const
{
    return rect;
}

/*void hrWidget::setSize(QSize s)
{
    rect.setWidth(s.width());
    rect.setHeight(s.height());
}*/

QVectorIterator<hrGraphicsItem> hrWidget::getItems() const
{
    return QVectorIterator<hrGraphicsItem>(items);
}

void hrWidget::setTopLeft(bool flag)
{
    if (flag)
    {
        corner = 0;
        corner |= topLeft;
    }
}

bool hrWidget::isTopLeft() const
{
    return corner & topLeft;
}

void hrWidget::setTopRight(bool flag)
{
    if (flag)
    {
        corner = 0;
        corner |= topRight;
    }
}

bool hrWidget::isTopRight() const
{
    return corner & topRight;
}

void hrWidget::setBottomLeft(bool flag)
{
    if (flag)
    {
        corner = 0;
        corner |= bottomLeft;
    }
}

bool hrWidget::isBottomLeft() const
{
    return corner & bottomLeft;
}

void hrWidget::setBottomRight(bool flag)
{
    if (flag)
    {
        corner = 0;
        corner |= bottomRight;
    }
}

bool hrWidget::isBottomRight() const
{
    return corner & bottomRight;
}
