// openhomm - open source clone of Heroes of Might and Magic III
// Copyright (C) 2009-2010 openhomm developers team (see AUTHORS)
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
#pragma once

#include "hrGraphicsItem.hpp"

class hrWidget : public QObject
{
    Q_OBJECT
public:
    hrWidget(QObject * parent = 0);

    Q_PROPERTY(bool topLeft READ isTopLeft WRITE setTopLeft)
    void setTopLeft(bool flag = false);
    bool isTopLeft() const;

    Q_PROPERTY(bool topRight READ isTopRight WRITE setTopRight)
    void setTopRight(bool flag = false);
    bool isTopRight() const;

    Q_PROPERTY(bool bottomLeft READ isBottomLeft WRITE setBottomLeft)
    void setBottomLeft(bool flag = false);
    bool isBottomLeft() const;

    Q_PROPERTY(bool bottomRight READ isBottomRight WRITE setBottomRight)
    void setBottomRight(bool flag = false);
    bool isBottomRight() const;

    QRect getRect() const;
    //void setSize(QSize s);

    QVectorIterator<hrGraphicsItem> getItems() const;

    QVector<hrGraphicsItem> items;

    QRect rect;

private:
    enum
    {
        topLeft = 0x1,
        topRight = 0x2,
        bottomLeft = 0x4,
        bottomRight = 0x8
    };
    int corner;
};
